<%@ WebHandler Language="C#" Class="EinarEgilsson.BinaryTreeImageGenerator" %>

using System;
using System.Data;
using System.Web;
using System.Collections;
using System.Web.Services;
using System.Web.Services.Protocols;
using System.Text.RegularExpressions;

namespace EinarEgilsson
{
    public class BinaryTreeImageGenerator : IHttpHandler
    {

        public void ProcessRequest(HttpContext context)
        {
            BinaryTree tree = new BinaryTree();

            if (context.Request.QueryString.Count == 1 &&
                Regex.IsMatch(context.Request.QueryString[0], @"\d+(;\d+)*"))
            {
                string qs = context.Request.QueryString[0];
                string[] numbers = qs.Split(';');

                foreach (string s in numbers)
                {
                    try
                    {
                        tree.Add(int.Parse(s));
                    }
                    catch (Exception) { /*don't care*/}
                }
            }

            BinaryTreeImage img = new BinaryTreeImage(tree.Root);
            context.Response.ContentType = "image/jpeg";
            img.WriteToStream(context.Response.OutputStream);
        }

        public bool IsReusable { get { return true; } }
    }
}
